package stats;

import game.GameObserver;

import java.util.Hashtable;
import java.util.Map;



/**
 * Counts all the times joint strategies were played. 
 * At the end of the game,
 * it can display the counts.
 * 
 * NOTE: this class represents the counts as ints.
 * @author maz
 *
 */
public class JointActionCounter implements GameObserver {
  Hashtable<JointAction,Integer> counts;
  
  /**
   * Constructs a joint action counter.
   */
  public JointActionCounter(){
    counts = new Hashtable<JointAction,Integer>();
  }
  
  @Override
  public void observeOutcome(int[] actions) {
    int[] actionCopy = new int[actions.length];
    System.arraycopy(actions, 0, actionCopy, 0, actions.length);
    JointAction joint = new JointAction(actionCopy);
    if (counts.containsKey(joint)){
      counts.put(joint,counts.get(joint)+1);
    } else {
      counts.put(joint, 1);
    }
    // TODO Auto-generated method stub
    
  }
  
  public void display(){
    System.out.println("Joint Actions:");
    for(Map.Entry<JointAction,Integer> entry:counts.entrySet()){
      System.out.println(entry.getKey()+":"+entry.getValue());
    }
  }
}
